Index: palm/trunk/UTIL/interpret_config.f90
===================================================================
--- palm/trunk/UTIL/interpret_config.f90	(revision 1)
+++ palm/trunk/UTIL/interpret_config.f90	(revision 1)
@@ -0,0 +1,544 @@
+ PROGRAM interpret_config
+
+!-------------------------------------------------------------------------------!
+! 21/07/97 - Siggi - Erste Fassung
+! 18/11/97 - Siggi - Komma in 2010-FORMAT hinzugefuegt
+! 29/04/05 - Siggi - extin wird auch fuer Input-Dateien ausgegeben
+! 29/06/05 - Siggi - Fehlermeldung ins englische uebertragen und ergaenzt
+! 01/11/05 - Siggi - s2b-Feld erlaubt den Wert locopt
+!
+! Letzte Aenderungen:
+! -------------------
+!
+! Beschreibung:
+! -------------
+! Interpretation der MRUN-Konfigurationsdatei. Ausgegeben werden ksh-Kommandos,
+! die anschliessend von MRUN ausgefuehrt werden muessen.
+!-------------------------------------------------------------------------------!
+
+    IMPLICIT NONE
+
+    CHARACTER (LEN=1)   ::  bs = ACHAR( 92 )   ! backslash (auf vpp sonst n. druckbar)
+    CHARACTER (LEN=20)  ::  do_remote, do_trace, host, localhost
+    CHARACTER (LEN=100) ::  config_file, icf
+    CHARACTER (LEN=300) ::  cond1, cond2, empty = REPEAT( ' ', 240 ), &
+                            for_cond1, for_cond2, for_host, input_list, &
+                            iolist, output_list, s1, s2, s2a, s2b, s2c, s3, &
+                            s3cond, s4, s5, s6, value, value_mrun,&
+                            var, zeile
+
+    INTEGER ::  dummy, i, icomment = 0, icond1, icond2, idatver = 0, iec = 0, &
+                ienvvar = 0, ifor_cond1, ifor_cond2, ifor_host, ihost, &
+                iic = 0, iicf, iin = 0, iinput_list, il, ilocalhost,  ioc = 0, &
+                ios, iout = 0, ioutput_list, is1, is2, is2a, is2b, is2c, &
+                is3, is3cond, is4, is5, is6, ivalue, ivalue_mrun, ivar, izeile
+
+    LOGICAL ::  found
+
+    CALL local_getenv( 'cond1', 5, cond1, icond1 )
+    CALL local_getenv( 'cond2', 5, cond2, icond2 )
+    CALL local_getenv( 'config_file', 11, config_file, il )
+    CALL local_getenv( 'do_remote', 9, do_remote, dummy )
+    CALL local_getenv( 'do_trace', 8, do_trace, dummy )
+    CALL local_getenv( 'host', 4, host, ihost )
+    CALL local_getenv( 'input_list', 10, input_list, iinput_list )
+    CALL local_getenv( 'interpreted_config_file', 23, icf, iicf )
+    CALL local_getenv( 'localhost', 9, localhost, ilocalhost )
+    CALL local_getenv( 'output_list', 11, output_list, ioutput_list )
+    iolist = input_list(1:iinput_list) // output_list(1:ioutput_list)
+
+    IF ( do_trace(1:4) == 'true' )  THEN
+       PRINT*,'*** cond1="',cond1(1:icond1),'"'
+       PRINT*,'*** cond2="',cond2(1:icond2),'"'
+       PRINT*,'*** config_file="',config_file(1:il),'"'
+       PRINT*,'*** do_remote="',do_remote,'"'
+       PRINT*,'*** do_trace="',do_trace,'"'
+       PRINT*,'*** host="',host(1:ihost),'"'
+       PRINT*,'*** input_list="',input_list(1:iinput_list),'"'
+       PRINT*,'*** interpreted_config_file="',icf(1:iicf),'"'
+       PRINT*,'*** localhost="',localhost(1:ilocalhost),'"'
+       PRINT*,'*** output_list="',output_list(1:ioutput_list),'"'
+    ENDIF
+
+    OPEN ( 1, FILE=config_file(1:il), FORM='formatted' )
+    OPEN ( 2, FILE=icf(1:iicf), FORM='formatted' )
+
+    READ ( 1, '(A)', IOSTAT=ios )  zeile
+
+
+    DO WHILE ( ios == 0 )
+
+       izeile = LEN_TRIM( zeile )
+
+       IF ( zeile(1:1) == '#' )  THEN
+          icomment = icomment + 1
+       ELSEIF ( zeile(1:1) == '%' )  THEN
+          ienvvar = ienvvar + 1
+          i = INDEX( zeile, ' ' )
+          var = zeile(2:i-1)
+          ivar = i - 2
+
+!
+!--       Achtung: Auf hpmuk und vpp sind nur die Variablen bekannt, die
+!--       von MRUN exportiert wurden!
+          CALL local_getenv( var, ivar, value_mrun, ivalue_mrun )
+
+!
+!--       Variable bekommt nur dann neuen Wert, wenn ihr per Shellscript-
+!--       Option noch keiner zugewiesen wurde
+          IF ( value_mrun(1:ivalue_mrun) == ''  .OR. &
+               value_mrun(1:ivalue_mrun) == '0' )  THEN
+
+             zeile(1:i) = empty(1:i)
+             zeile = ADJUSTL( zeile )
+             i = INDEX( zeile, ' ' )
+             value = zeile(1:i-1)
+             ivalue = i - 1
+
+             zeile(1:i) = empty(1:i)
+             zeile = ADJUSTL( zeile )
+             i = INDEX( zeile, ' ' )
+
+             IF ( i /= 1 )  THEN
+                for_host = zeile(1:i-1)
+                ifor_host = i - 1
+
+                zeile(1:i) = empty(1:i)
+                zeile = ADJUSTL( zeile )
+                i = INDEX( zeile, ' ' )
+
+                IF ( i /= 1 )  THEN
+                   for_cond1 = zeile(1:i-1)
+                   ifor_cond1 = i - 1
+
+                   zeile(1:i) = empty(1:i)
+                   zeile = ADJUSTL( zeile )
+                   i = INDEX( zeile, ' ' )
+
+                   IF ( i /= 1 )  THEN
+                      for_cond2 = zeile(1:i-1)
+                      ifor_cond2 = i - 1
+                   ELSE
+                      for_cond2 = ''
+                      ifor_cond2 = 0
+                   ENDIF
+                ELSE
+                   for_cond1 = ''
+                   ifor_cond1 = 0
+                   for_cond2 = ''
+                   ifor_cond2 = 0
+                ENDIF
+             ELSE
+                for_host = ' '
+                ifor_host = 1
+                for_cond1 = ''
+                ifor_cond1 = 0
+                for_cond2 = ''
+                ifor_cond2 = 0
+             ENDIF
+             IF ( do_trace(1:4) == 'true' )  THEN
+                PRINT*,'var="',var(1:ivar),'"'
+                PRINT*,'value="',value(1:ivalue),'"'
+                PRINT*,'for_host="',for_host(1:ifor_host),'"'
+                PRINT*,'for_cond1="',for_cond1(1:ifor_cond1),'"'
+                PRINT*,'for_cond2="',for_cond2(1:ifor_cond2),'"'
+             ENDIF
+!
+!--          Geltungsbereich pruefen und evtl. Variable ausgeben
+             IF ( for_host == ' '  .OR.  ( &
+                  for_host(1:ifor_host) == host(1:ihost)  .AND. &
+                  for_cond1(1:ifor_cond1) == cond1(1:icond1)  .AND. &
+                  for_cond2(1:ifor_cond2) == cond2(1:icond2) &
+                                         )  .OR. ( &
+                  INDEX( iolist, for_host(1:ifor_host) ) /= 0 &
+                                                 ) )  THEN
+
+!
+!--             Zuerst Doppelpunkte durch Blanks ersetzen (aber doppelt
+!--             auftretende Doppelpunkte durch einen Doppelpunkt)
+                i = 0
+                DO
+                   i = i + 1
+                   IF ( i > ivalue )  EXIT
+                   IF ( value(i:i) == ':' )  THEN
+                      IF ( value(i+1:i+1) == ':' )  THEN
+                         value = value(1:i) // value(i+2:ivalue)
+                         ivalue = ivalue - 1
+                      ELSE
+                         value(i:i) = ' '
+                      ENDIF
+                   ENDIF
+                ENDDO
+
+!
+!--             Variable ausgeben
+                WRITE (2,2200)  var(1:ivar), bs, value(1:ivalue), bs, &
+                                var(1:ivar)
+ 2200           FORMAT ('eval ',A,'=',A,'"',A,A,'"'/'export ',A)
+
+                IF ( do_trace(1:4) == 'true' )  THEN
+                   WRITE (2,2201)  bs, var(1:ivar), value(1:ivalue)
+ 2201              FORMAT ('printf "',A,'n*** ENVIRONMENT-VARIABLE ',A,' = ',A)
+                ENDIF
+
+             ENDIF
+
+!
+!--          Variable "host" muss gleich ausgewertet werden, da mit ihr ein
+!--          neuer Geltungsbereich festgelegt wird
+             IF ( var(1:ivar) == 'host' )  THEN
+
+                host  = value(1:ivalue)
+                ihost = ivalue
+
+!                IF ( host(1:ihost) /= localhost(1:ilocalhost) )  THEN
+!
+!                   SELECT CASE ( value(1:ivalue) )
+!
+!                      CASE ( 'cray','hpcs','t3d','t3eb','t3eh','unics','vpp' )
+!
+!                         dummy = 1
+!
+!                      CASE DEFAULT
+!
+!                         WRITE (2,2202)  bs, bs, value(1:ivalue), bs, bs
+! 2202                    FORMAT ('printf "',A,'n +++ Auf Zielrechner ',A,'"',A,A,'" ist kein NQS-System vorhanden"'/ &
+!                                 'printf "',A,'n     Programmlauf kann deshalb nicht gestartet werden"'/ &
+!                                 'locat=nqs; exit')
+!                         STOP
+!
+!                   END SELECT
+!
+!                ENDIF
+
+             ENDIF
+
+          ENDIF
+
+       ELSEIF ( zeile(1:3) == 'EC:' )  THEN
+!
+!--       Error-Kommandos
+          iec = iec + 1
+          IF ( iec < 10 )  THEN
+             WRITE (2,'(''err_command['',I1,'']="'',A,''"'')')  iec, &
+                                                                zeile(4:izeile)
+          ELSEIF ( iec < 100 )  THEN
+             WRITE (2,'(''err_command['',I2,'']="'',A,''"'')')  iec, &
+                                                                zeile(4:izeile)
+          ELSE
+             WRITE (2,'(''err_command['',I3,'']="'',A,''"'')')  iec, &
+                                                                zeile(4:izeile)
+          ENDIF
+
+       ELSEIF ( zeile(1:3) == 'IC:' )  THEN
+!
+!--       Input-Kommandos
+          iic = iic + 1
+          IF ( iic < 10 )  THEN
+             WRITE (2,'(''in_command['',I1,'']="'',A,''"'')')  iic, &
+                                                               zeile(4:izeile)
+          ELSEIF ( iic < 100 )  THEN
+             WRITE (2,'(''in_command['',I2,'']="'',A,''"'')')  iic, &
+                                                               zeile(4:izeile)
+          ELSE
+             WRITE (2,'(''in_command['',I3,'']="'',A,''"'')')  iic, &
+                                                               zeile(4:izeile)
+          ENDIF
+
+       ELSEIF ( zeile(1:3) == 'OC:' )  THEN
+!
+!--       Output-Kommandos
+          ioc = ioc + 1
+          IF ( ioc < 10 )  THEN
+             WRITE (2,'(''out_command['',I1,'']="'',A,''"'')')  ioc, &
+                                                                zeile(4:izeile)
+          ELSEIF ( ioc < 100 )  THEN
+             WRITE (2,'(''out_command['',I2,'']="'',A,''"'')')  ioc, &
+                                                                zeile(4:izeile)
+          ELSE
+             WRITE (2,'(''out_command['',I3,'']="'',A,''"'')')  ioc, &
+                                                                zeile(4:izeile)
+          ENDIF
+
+       ELSE
+!
+!--       Dateiverbindungen
+          idatver = idatver + 1
+!
+!--       Lokaler Name
+          i   = INDEX( zeile , ' ' )
+          s1  = zeile(1:i-1)
+          is1 = i-1
+!
+!--       Dateieigenschaften
+          zeile = ADJUSTL( zeile(i:izeile) )
+          i   = INDEX( zeile , ' ' )
+          s2  = zeile(1:i-1)
+          is2 = i-1
+!
+!--       Geltungsbereich
+          zeile = ADJUSTL( zeile(i:izeile) )
+          i   = INDEX( zeile , ' ' )
+          s3  = zeile(1:i-1)
+          is3 = i-1
+!
+!--       Pfadname
+          zeile = ADJUSTL( zeile(i:izeile) )
+          i   = INDEX( zeile , ' ' )
+          s4  = zeile(1:i-1)
+          is4 = i-1
+!
+!--       evtl. Extension
+          zeile = ADJUSTL( zeile(i:izeile) )
+          i = INDEX( zeile , ' ' )
+          IF ( i == 1 )  THEN
+             s5  = ' '
+             is5 = 1
+             s6  = ' '
+             is6 = 1
+          ELSE
+             s5  = zeile(1:i-1)
+             is5 = i-1
+!
+!--          evtl. 2. Extension
+             zeile = ADJUSTL( zeile(i:izeile) )
+             i = INDEX( zeile , ' ' )
+             IF ( i == 1 )  THEN
+                s6  = ' '
+                is6 = 1
+             ELSE
+                s6  = zeile(1:i-1)
+                is6 = i-1
+             ENDIF
+          ENDIF
+
+!
+!--       Dateieigenschaften aufspalten
+          i = INDEX( s2 , ':' )
+          IF ( i == 0 )  THEN
+             s2a  = s2
+             is2a = is2
+             s2b  = ''
+             is2b = 0
+             s2c  = ''
+             is2c = 0
+          ELSE
+             s2a  = s2(1:i-1)
+             is2a = i-1
+             s2   = s2(i+1:is2)
+
+             i = INDEX( s2 , ':' )
+             IF ( i == 0 )  THEN
+                s2b  = s2
+                is2b = LEN_TRIM( s2 )
+                s2c  = ''
+                is2c = 0
+             ELSE
+                s2b  = s2(1:i-1)
+                is2b = i-1
+                s2c  = s2(i+1:)
+                is2c = LEN_TRIM( s2c )
+             ENDIF
+          ENDIF
+!
+!--       Pruefung, ob Eingabedateiverbindung abgespeichert werden soll
+          IF ( s2a(1:is2a) == 'in'  .AND.  .NOT. (                     &
+               do_remote(1:4) == 'true'  .AND.                         &
+               ( s2b(1:is2b) == 'loc'  .OR.  s2b(1:is2b) == 'locopt' ) &
+                                                 ) )  THEN
+             found = .FALSE.
+             i = INDEX( s3 , ':' )
+             IF ( i == 0 )  THEN
+                s3cond  = s3
+                is3cond = LEN_TRIM( s3cond )
+             ELSE
+                s3cond  = s3(1:i-1)
+                is3cond = i-1
+                s3      = s3(i+1:)
+             ENDIF
+
+             DO WHILE ( s3cond(1:1) /= ' ' )
+
+                IF ( INDEX( input_list(1:iinput_list) , s3cond(1:is3cond) ) /= 0 &
+                     .OR.  s3cond(1:is3cond) == '-' )  THEN
+                   found = .TRUE.
+                ENDIF
+
+                IF ( s3(1:1) == ' ' )  THEN
+                   s3cond = ' '
+                ELSE
+                   i = INDEX( s3 , ':' )
+                   IF ( i == 0 )  THEN
+                      s3cond  = s3
+                      is3cond = LEN_TRIM( s3cond )
+                      s3      = ' '
+                   ELSE
+                      s3cond  = s3(1:i-1)
+                      is3cond = i-1
+                      s3      = s3(i+1:)
+                   ENDIF
+                ENDIF
+
+             ENDDO
+
+!
+!--          Wenn Geltungsbereich erfuellt, dann Dateiverbindung abspeichern
+             IF ( found )  THEN
+
+                iin = iin + 1
+                IF ( iin < 10 )  THEN
+                   WRITE (2,2000)  iin, s1(1:is1), iin, s2b(1:is2b), &
+                                   iin, s2c(1:is2c), &
+                                   iin, s3(1:is3), iin, s4(1:is4), &
+                                   iin, s5(1:is5), iin, s6(1:is6)
+2000               FORMAT ('localin[',I1,']="',A,'"; transin[',I1,']="',A, &
+                           '"; actionin[',I1,']="',A, &
+                           '"; typein[',I1,']="',A,'"'/'pathin[',I1,']="',A, &
+                           '"; endin[',I1,']="',A,'"; extin[',I1,']="',A,'"')
+                ELSEIF ( iin < 100 )  THEN
+                   WRITE (2,2001)  iin, s1(1:is1), iin, s2b(1:is2b), &
+                                   iin, s2c(1:is2c), &
+                                   iin, s3(1:is3), iin, s4(1:is4), &
+                                   iin, s5(1:is5), iin, s6(1:is6)
+2001               FORMAT ('localin[',I2,']="',A,'"; transin[',I2,']="',A, &
+                           '"; actionin[',I2,']="',A, &
+                           '"; typein[',I2,']="',A,'"'/'pathin[',I2,']="',A, &
+                           '"; endin[',I2,']="',A,'"; extin[',I2,']="',A,'"')
+                ELSE
+                   WRITE (2,2002)  iin, s1(1:is1), iin, s2b(1:is2b), &
+                                   iin, s2c(1:is2c), &
+                                   iin, s3(1:is3), iin, s4(1:is4), &
+                                   iin, s5(1:is5), iin, s6(1:is6)
+2002               FORMAT ('localin[',I3,']="',A,'"; transin[',I3,']="',A, &
+                           '"; actionin[',I3,']="',A, &
+                           '"; typein[',I3,']="',A,'"'/'pathin[',I3,']="',A, &
+                           '"; endin[',I3,']="',A,'"; extin[',I3,']="',A,'"')
+                ENDIF
+             ENDIF
+
+          ELSEIF ( s2a(1:is2a) == 'out'  .AND.  .NOT. ( &
+                   do_remote(1:4) == 'true'  .AND.  s2b(1:is2b) == 'loc' &
+                                                      ) )  THEN
+!
+!--          Pruefung, ob Ausgabedateiverbindung abgespeichert werden soll
+             found = .FALSE.
+             i = INDEX( s3 , ':' )
+             IF ( i == 0 )  THEN
+                s3cond  = s3
+                is3cond = LEN_TRIM( s3cond )
+             ELSE
+                s3cond  = s3(1:i-1)
+                is3cond = i-1
+                s3      = s3(i+1:)
+             ENDIF
+
+             DO WHILE ( s3cond(1:1) /= ' ' )
+
+                IF ( INDEX( output_list(1:ioutput_list) , s3cond(1:is3cond) ) /= 0 &
+                     .OR.  s3cond(1:is3cond) == '-' )  THEN
+                   found = .TRUE.
+                ENDIF
+
+                IF ( s3(1:1) == ' ' )  THEN
+                   s3cond = ' '
+                ELSE
+                   i = INDEX( s3 , ':' )
+                   IF ( i == 0 )  THEN
+                      s3cond  = s3
+                      is3cond = LEN_TRIM( s3cond )
+                      s3      = ' '
+                   ELSE
+                      s3cond  = s3(1:i-1)
+                      is3cond = i-1
+                      s3      = s3(i+1:)
+                   ENDIF
+                ENDIF
+
+             ENDDO
+!
+!--          Wenn Geltungsbereich erfuellt, dann Dateiverbindung abspeichern
+             IF ( found )  THEN
+
+                iout = iout + 1
+                IF ( iout < 10 )  THEN
+                   WRITE (2,2003)  iout, s1(1:is1), iout, s2c(1:is2c), &
+                                   iout, s3(1:is3), iout, s4(1:is4), &
+                                   iout, s5(1:is5), iout, s6(1:is6)
+ 2003              FORMAT ('localout[',I1,']="',A,'"; actionout[',I1,']="',A, &
+                           '"; typeout[',I1,']="',A,'"'/'pathout[',I1,']="',A, &
+                           '"; endout[',I1,']="',A,'"; extout[',I1,']="',A,'"')
+                ELSEIF ( iin < 100 )  THEN
+                      WRITE (2,2004)  iout, s1(1:is1), iout, s2c(1:is2c), &
+                                      iout, s3(1:is3), iout, s4(1:is4), &
+                                      iout, s5(1:is5), iout, s6(1:is6)
+ 2004              FORMAT ('localout[',I2,']="',A,'"; actionout[',I2,']="',A, &
+                           '"; typeout[',I2,']="',A,'"'/'pathout[',I2,']="',A, &
+                           '"; endout[',I2,']="',A,'"; extout[',I2,']="',A,'"')
+                ELSE
+                      WRITE (2,2005)  iout, s1(1:is1), iout, s2c(1:is2c), &
+                                      iout, s3(1:is3), iout, s4(1:is4), &
+                                      iout, s5(1:is5), iout, s6(1:is6)
+ 2005              FORMAT ('localout[',I3,']="',A,'"; actionout[',I3,']="',A, &
+                           '"; typeout[',I3,']="',A,'"'/'pathout[',I3,']="',A, &
+                           '"; endout[',I3,']="',A,'"; extout[',I3,']="',A,'"')
+                ENDIF
+             ENDIF
+
+          ELSEIF ( s2a(1:is2a) /= 'in'  .AND.  s2a(1:is2a) /= 'out' )  THEN
+!
+!--          Kein gueltiger Wert fuer I/O-Feld
+             WRITE (2,2010)  bs, bs, config_file(1:il), bs, bs, s2a(1:is2a), &
+                             bs, bs, bs, bs, bs, bs, bs
+ 2010        FORMAT ('printf "',A,'n',A,'n +++ I/O-field in configuration ', &
+                     'file ',A, ' has the illegal"'/ &
+                     'printf "',A,'n     value ',A,'"',A,A,'". Only ', &
+                     A,'"in',A,'" or ',A,'"out',A,'" are allowed!"'/ &
+                     'printf "',A,'n     The error may be caused by an', &
+                     ' empty line at the end of the "'/ &
+                     'printf "',A,'n     configuration file."' &
+                    )
+             WRITE (2,'(''locat=connect; exit'')')
+             STOP
+          ENDIF
+          
+       ENDIF
+
+       READ( 1, '(A)', IOSTAT=ios )  zeile
+
+    ENDDO
+
+!
+!-- Ausgabe der Anzahl von gefundenen Zeilen
+    IF ( iec > 0 )  WRITE (2,'(''(( iec = '',I3,'' ))'')')  iec
+    IF ( iic > 0 )  WRITE (2,'(''(( iic = '',I3,'' ))'')')  iic
+    IF ( ioc > 0 )  WRITE (2,'(''(( ioc = '',I3,'' ))'')')  ioc
+    IF ( iin > 0 )  WRITE (2,'(''(( iin = '',I3,'' ))'')')  iin
+    IF ( iout > 0 )  WRITE (2,'(''(( iout = '',I3,'' ))'')')  iout
+
+    IF ( do_trace(1:4) == 'true' )  THEN
+       PRINT*,' '
+       PRINT*,'*** Inhalt von: ',config_file(1:il)
+       PRINT*,icomment,' Kommentarzeilen'
+       PRINT*,ienvvar,' Environment-Variablen-Vereinbarungen'
+       PRINT*,iec,' Error-Kommandos'
+       PRINT*,iic,' Input-Kommandos'
+       PRINT*,ioc,' Output-Kommandos'
+       PRINT*,idatver,' Dateiverbindungs-Anweisungen'
+       PRINT*,'Davon interpretiert:'
+       PRINT*,iin,' Eingabedateien'
+       PRINT*,iout,' Ausgabedateien'
+    ENDIF
+
+ END PROGRAM interpret_config
+
+
+
+ SUBROUTINE local_getenv( var, ivar, value, ivalue )
+
+    CHARACTER (LEN=*) ::  var, value
+    INTEGER           ::  ivalue, ivar
+
+    CALL GETENV( var(1:ivar), value )
+    ivalue = LEN_TRIM( value )
+
+ END SUBROUTINE local_getenv    
Index: palm/trunk/UTIL/read_palm_2d_netcdf_data.f90
===================================================================
--- palm/trunk/UTIL/read_palm_2d_netcdf_data.f90	(revision 1)
+++ palm/trunk/UTIL/read_palm_2d_netcdf_data.f90	(revision 1)
@@ -0,0 +1,169 @@
+ PROGRAM read_palm_2d_netcdf_data
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
+!
+! Former revisions:
+! -----------------
+!
+! This routine must be compiled with:
+! decalpha:
+!    f95 -cpp -D__netcdf -fast -r8 -I/usr/local/netcdf-3.5.1/include
+!    -L/usr/local/netcdf-3.5.1/lib -lnetcdf
+! IBM-Regatta:
+!    xlf95 -qsuffix=cpp=f90 -WF,-D__netcdf -qrealsize=8 -q64 -qmaxmem=-1 -Q
+!    -I /aws/dataformats/netcdf-3.6.0-p1/64-32/include
+!    -L/aws/dataformats/netcdf-3.6.0-p1/64-32/lib -lnetcdf -O3
+! IBM-Regatta KISTI:
+!    xlf95 -qsuffix=cpp=f90 -WF,-D__netcdf -qrealsize=8 -q64 -qmaxmem=-1 -Q
+!    -I /applic/netcdf64/src/f90
+!    -L/applic/lib/NETCDF64 -lnetcdf -O3
+! IBM-Regatta Yonsei (gfdl5):
+!    xlf95 -qsuffix=cpp=f90 -WF,-D__netcdf -qrealsize=8 -q64 -qmaxmem=-1 -Q
+!    -I /usr1/users/raasch/pub/netcdf-3.6.0-p1/include
+!    -L/usr1/users/raasch/pub/netcdf-3.6.0-p1/lib -lnetcdf -O3
+! IMUK:
+!    ifort combine...f90 -o combine...x
+!    -cpp -D__netcdf -I /muksoft/packages/netcdf/linux/include -axW -r8 -nbs
+!    -Vaxlib -L /muksoft/packages/netcdf/linux/lib -lnetcdf
+! NEC-SX6:
+!    sxf90 combine...f90 -o combine...x 
+!    -I /pool/SX-6/netcdf/netcdf-3.6.0-p1/include  -C hopt -Wf '-A idbl4'
+!    -D__netcdf -L/pool/SX-6/netcdf/netcdf-3.6.0-p1/lib -lnetcdf
+!------------------------------------------------------------------------------!
+
+    USE netcdf
+
+    IMPLICIT NONE
+
+!
+!-- Local variables
+    CHARACTER (LEN=10)   ::  dimname, var_name
+    CHARACTER (LEN=40)   ::  filename
+
+    CHARACTER (LEN=2000) ::  var_list
+
+    INTEGER ::  i, j, k, nc_stat, pos, time_step
+
+    INTEGER ::  current_level, current_var, id_set, id_var_time, num_var
+
+    INTEGER, DIMENSION(4) ::  id_dims_loc
+
+    INTEGER, DIMENSION(4) ::  id_dims
+
+    INTEGER, DIMENSION(1000) ::  id_var, levels
+
+!    REAL, DIMENSION(0:576,0:128,3,6) ::  pf
+    REAL, DIMENSION(0:576,2,0:64,6) ::  pf
+
+
+
+    filename = 'ibmh_rinne_xz_av.nc'
+    nc_stat = NF90_OPEN( filename, NF90_WRITE, id_set )
+    IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 1 )
+
+!
+!-- Get the list of variables (order of variables corresponds with the
+!-- order of data on the binary file)
+    var_list = ' '    ! GET_ATT does not assign trailing blanks
+    nc_stat = NF90_GET_ATT( id_set, NF90_GLOBAL, 'VAR_LIST', var_list )
+    IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 2 )
+
+!
+!-- Inquire id of the time coordinate variable
+    nc_stat = NF90_INQ_VARID( id_set, 'time', id_var_time )
+    IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 3 )
+
+!
+!-- Count number of variables; there is one more semicolon in the
+!-- string than variable names
+    num_var = -1
+    DO  i = 1, LEN( var_list )
+       IF ( var_list(i:i) == ';' )  num_var = num_var + 1
+    ENDDO
+
+!
+!-- Extract the variable names from the list and inquire their NetCDF IDs
+    pos = INDEX( var_list, ';' )
+!
+!-- Loop over all variables
+    DO  i = 1, num_var
+
+!
+!--    Extract variable name from list
+       var_list = var_list(pos+1:)
+       pos = INDEX( var_list, ';' )
+       var_name = var_list(1:pos-1)
+
+!
+!--    Get variable ID from name
+       nc_stat = NF90_INQ_VARID( id_set, TRIM( var_name ), id_var(i) )
+       IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 4 )
+
+!
+!--    Get number of x/y/z levels for that variable
+       nc_stat = NF90_INQUIRE_VARIABLE( id_set, id_var(i), &
+                                        dimids = id_dims_loc )
+       IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 5 )
+       id_dims = id_dims_loc
+
+!
+!--    Inquire dimension ID
+       DO  j = 1, 4
+          nc_stat = NF90_INQUIRE_DIMENSION( id_set, id_dims(j),&
+                                            dimname, levels(i) )
+          IF ( nc_stat /= NF90_NOERR ) CALL handle_netcdf_error( 6 )
+       ENDDO
+
+       PRINT*, '*** reading array ', i
+!       nc_stat = NF90_GET_VAR( id_set, id_var(i), pf(0:576,0:128,1:3,i), &
+!                                start = (/ 1, 1, 1, 1 /), &
+!                                count = (/ 577, 129, 3, 1 /) )
+       nc_stat = NF90_GET_VAR( id_set, id_var(i), pf(0:576,1:2,0:64,i), &
+                                start = (/ 1, 1, 1, 1 /), &
+                                count = (/ 577, 2, 65, 1 /) )
+       IF ( nc_stat /= NF90_NOERR )  CALL handle_netcdf_error( 7+i )
+                  
+    ENDDO
+
+    PRINT*, ' '
+    i = 190
+    j =  60
+
+!    DO  k = 3, 1, -1
+!       WRITE ( *, '(F5.2,1X,F5.2,1X,F6.3,1X,F6.2,1X,F6.4,1X,F6.4)' )  &
+!          pf(i,j,k,1), pf(i,j,k,2), pf(i,j,k,3), pf(i,j,k,4), pf(i,j,k,5), &
+!          pf(i,j,k,6)
+!    ENDDO
+    DO  k = 2, 0, -1
+       WRITE ( *, '(F5.2,1X,F5.2,1X,F6.3,1X,F6.2,1X,F6.4,1X,F6.4)' )  &
+          pf(i,1,k,1), pf(i,1,k,2), pf(i,1,k,3), pf(i,1,k,4), pf(i,1,k,5), &
+          pf(i,1,k,6)
+    ENDDO
+
+
+ CONTAINS
+
+
+    SUBROUTINE handle_netcdf_error( errno )
+!
+!--    Prints out a text message corresponding to the current NetCDF status
+
+       IMPLICIT NONE
+
+       INTEGER, INTENT(IN) ::  errno
+
+       IF ( nc_stat /= NF90_NOERR )  THEN
+          PRINT*, '+++ read_palm_2d_netcdf_data  netcdf: ', errno, &
+                  TRIM( nf90_strerror( nc_stat ) )
+       ENDIF
+
+    END SUBROUTINE handle_netcdf_error
+
+
+ END PROGRAM read_palm_2d_netcdf_data
+
+
+
